package java.util.zip;

import java.io.IOException;
import java.io.OutputStream;
import java.io.FilterOutputStream;

public class CheckedOutputStream extends FilterOutputStream
{
    private Checksum cksum;
    
    public CheckedOutputStream(OutputStream out, Checksum cksum) {
        super(out);
        this.cksum = cksum;
    }
    
    @Override
    public void write(int n) throws IOException {
        this.out.write(n);
        this.cksum.update(n);
    }
    
    @Override
    public void write(byte[] b, int off, int len) throws IOException {
        this.out.write(b, off, len);
        this.cksum.update(b, off, len);
    }
    
    public Checksum getChecksum() {
        return this.cksum;
    }
}
